// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BlendFunc_Corde_HeaderFile
#define _BlendFunc_Corde_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _Handle_Adaptor3d_HSurface_HeaderFile
#include <Handle_Adaptor3d_HSurface.hxx>
#endif
#ifndef _Handle_Adaptor3d_HCurve_HeaderFile
#include <Handle_Adaptor3d_HCurve.hxx>
#endif
#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _gp_Pnt2d_HeaderFile
#include <gp_Pnt2d.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _gp_Vec_HeaderFile
#include <gp_Vec.hxx>
#endif
#ifndef _gp_Vec2d_HeaderFile
#include <gp_Vec2d.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Adaptor3d_HSurface;
class Adaptor3d_HCurve;
class Standard_DomainError;
class math_Vector;
class math_Matrix;
class gp_Pnt;
class gp_Vec;
class gp_Vec2d;


//! Cette fonction calcule le point pts sur la courbe intersection <br>
//!          entre la normale  a  une courbe (guide) en un parametre choisi <br>
//!          et une surface  (surf), tel que pts soit a une distance <br>
//!          donnee de guide. <br>
//!          X(1),X(2) sont les parametres U,V de pts sur surf. <br>
class BlendFunc_Corde  {
public:

  void* operator new(size_t,void* anAddress) 
  {
    return anAddress;
  }
  void* operator new(size_t size) 
  {
    return Standard::Allocate(size); 
  }
  void  operator delete(void *anAddress) 
  {
    if (anAddress) Standard::Free((Standard_Address&)anAddress); 
  }

  
  Standard_EXPORT   BlendFunc_Corde(const Handle(Adaptor3d_HSurface)& S,const Handle(Adaptor3d_HCurve)& CGuide);
  
  Standard_EXPORT     void SetParam(const Standard_Real Param) ;
  
  Standard_EXPORT     void SetDist(const Standard_Real Dist) ;
  //! computes the values <F> of the Function for the <br>
//!          variable <X>. <br>
//!          Returns True if the computation was done successfully, <br>
//!          False otherwise. <br>
  Standard_EXPORT     Standard_Boolean Value(const math_Vector& X,math_Vector& F) ;
  //! returns the values <D> of the derivatives for the <br>
//!          variable <X>. <br>
//!          Returns True if the computation was done successfully, <br>
//!          False otherwise. <br>
  Standard_EXPORT     Standard_Boolean Derivatives(const math_Vector& X,math_Matrix& D) ;
  
  Standard_EXPORT    const gp_Pnt& PointOnS() const;
  //! returns the point of parameter <Param> on CGuide <br>
  Standard_EXPORT    const gp_Pnt& PointOnGuide() const;
  //! returns the normal to CGuide at Ptgui. <br>
  Standard_EXPORT    const gp_Vec& NPlan() const;
  //! Returns True when it is not possible to compute <br>
//!          the tangent vectors at PointOnS. <br>
  Standard_EXPORT     Standard_Boolean IsTangencyPoint() const;
  //! Returns the tangent vector at PointOnS, in 3d space. <br>
  Standard_EXPORT    const gp_Vec& TangentOnS() const;
  //! Returns the tangent vector at PointOnS, in the <br>
//!          parametric space of the first surface. <br>
  Standard_EXPORT    const gp_Vec2d& Tangent2dOnS() const;
  //! Derivee de la fonction par rapport au parametre <br>
//!          de la ligne guide <br>
  Standard_EXPORT     void DerFguide(const math_Vector& Sol,gp_Vec2d& DerF) ;
  //! Returns False if Sol is not solution else returns <br>
//!          True and updates the fields tgs and tg2d <br>
  Standard_EXPORT     Standard_Boolean IsSolution(const math_Vector& Sol,const Standard_Real Tol) ;





protected:





private:



Handle_Adaptor3d_HSurface surf;
Handle_Adaptor3d_HCurve guide;
gp_Pnt pts;
gp_Pnt2d pt2d;
Standard_Real dis;
Standard_Real normtg;
Standard_Real theD;
gp_Pnt ptgui;
gp_Vec nplan;
gp_Vec d1gui;
gp_Vec d2gui;
gp_Vec tgs;
gp_Vec2d tg2d;
Standard_Boolean istangent;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
